#! /bin/sh

sourcefile=../linux/sysmask.c
lines=270

tester=`grep -E "/\*.*( __NR_|sys_ni_syscall)" $sourcefile | \
	sed 's/^0,/---,/' | \
	awk 	'BEGIN {a=0};
		{print a","$0; a++}'`

testcnt=`echo "$tester" | grep -c .`
if [ $testcnt != $lines ]; then
 echo "$tester

Bad number $testcnt: please debug.
"
 exit
fi

calls=`echo "$tester" | grep -v "sys_ni_syscall" | \
	sed 's!/\*!!;s!\*/!!;s!sys_!!;s! old_!old_!;s/SM1_//g' | \
	awk -F'' '{print $1 $3}' | \
	tr -d '[[:blank:]]' | tr ',|' ':,' | \
	awk -F\: '{print $1":	"$3":	"tolower($2)":	"}'

`

echo "$calls" | sort -d >/ramdisk/syscalls

join -t: -o 1.1,1.2,1.3,2.4 -a1 /ramdisk/syscalls syscalls.m2 | sort -n | \
	sed 's/,/, /g' >syscalls

cat <<@ >syscalls-bynumber.html
<html><body>
<center><h1>List of syscall masks by call number</h1></center>
Here we give the list of Linux syscalls and the sysmask masks acting on
them, up to call number 269. Syscalls with higher numbers
are masked by the mask "new".
<p>
Please note that many library functions are based on system calls. For
example, fopen() uses open, printf() uses write, ftell() uses lseek, malloc() uses brk. The
masking of a syscall will break EVERY library function that depends on it.
<p>
<center><table border=2 width=80% cellpadding=3 cellspacing=1>
<tr><th>Number<th>name<th>Hard masks<th width=30%>partial masks</tr>
@

cat syscalls | tr -d '	' | \
	awk -F: '{print "<tr><td align=right>"$1"<td>"$2"<td>"$3"<td>"$4}' \
	>>syscalls-bynumber.html
cat <<@ >>syscalls-bynumber.html
</table></center>
</body></html>
@

cat <<@ >syscalls-byname.html
<html><body>
<center><h1>List of syscall masks by name</h1></center>
Here we give the list of Linux syscalls and the sysmask masks acting on
them, up to call number 269. Syscalls with higher numbers
are masked by the mask "new".
<p>
Please note that many library functions are based on system calls. For
example, fopen() uses open, printf() uses write, ftell() uses lseek, malloc() uses brk. The
masking of a syscall will break EVERY library function that depends on it.
<p>
<center><table border=2 width=80% cellpadding=3 cellspacing=1>
<tr><th>Name<th>number<th>Hard masks<th width=30%>partial masks</tr>
@

sort -d -t: -k2 <syscalls | tr -d '	' | \
	awk -F: '{print "<tr><td>"$2"<td align=center>"$1"<td>"$3"<td>"$4}' \
	>>syscalls-byname.html
cat <<@ >>syscalls-byname.html
</table></center>
</body></html>
@

exit

