/*    Copyright (C) 2005 XIAO, Gang of Universite de Nice - Sophia Antipolis
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

	/* smkd definitions */

#include <stdio.h>
#include <sys/types.h>
#include <errno.h>
/* use kernel string macros instead of gcc library */
#define __KERNEL__ 1
#include <linux/stat.h>
#include <linux/string.h>
#include <linux/socket.h>
#undef __KERNEL__
#include <asm/fcntl.h>
#include <linux/net.h>
#include <linux/capability.h>
#include "syscalls.h"
#include "sysmask.h"
#include "smk.h"

#define rename sys_rename

static inline _syscall3(long,sysmask,long,x,void *,y,long,z)
static inline _syscall2(long,nanosleep,struct timespec *,x,struct timespec *,y)
static inline _syscall1(long,close,long,fd)
static inline _syscall3(long,open,const char *,fname,long,flag,mode_t,mode)
static inline _syscall2(long,creat,const char *,fname,mode_t,mode)
static inline _syscall3(long,read,long,fd,char *,str,long,l)
static inline _syscall3(long,write,long,fd,char *,str,long,l)
static inline _syscall3(off_t,lseek,int,fd,off_t,offset,int,whence)
static inline _syscall2(long,chmod,const char *,path,mode_t,mode)
static inline _syscall2(int,rename,const char *,old,const char *,new)
static inline _syscall2(long,stat,const char *,path,struct stat *,buf)
static inline _syscall3(long,chown,const char *,path,uid_t, uid, gid_t, gid)
static inline _syscall0(long,fork)
static inline _syscall1(time_t,time, time_t *,t)
static inline _syscall2(int,utime, const char *,fname, void *,buf)
static inline _syscall2(long,gettimeofday, void *, tv, void *, tz)
static inline _syscall1(long,nice, int, inc)

#define CONFCACHESIZE	(2048*1024)
#define CONFCACHELIM	4096	/* number of token configurations */
#define CONFLEN		65536	/* size limit of a conf file */
#define CONFBLOCKS	1024	/* blocks in a conf file */
#define CONFLINES	4096	/* lines in a conf file */
#define USERCQUOTA	(256*1024)	/* conf cache buffer quota for a user */
#define USERTQUOTA	256	/* conf cache token quota for a user */
#define LOGBUFLEN	32768	/* length of temporary log buffer */
#define LOGLEN		(4096*1024)	/* 4M: length of logfile before rotating */
#define PASSWDLEN	(256*1024)	/* limit to /etc/passwd */
#define ACCOUNTLIM	16384	/* limit to user accounts in /etc/passwd */
#define NAMELEN_MAX	63	/* variable name */
#define STRLEN_MAX	32768	/* any string; not used */
#define LOGLEN_MAX	256	/* limit to log line item */
#define BACKUP_MAX	16	/* at most that many chains of backup */
#define STAT_DELAY	4	/* in seconds */
#define LISTLIM		200	/* items in a list, cannot exceed 255 */
#define LINELEN_MIN	15	/* minimal buffer size for a line */

enum {conf_mask, conf_open, conf_exec, conf_sock, conf_call, conf_trig};

enum {conftype_empty, conftype_pre, conftype_path, conftype_path2,
      conftype_def};

void readfile(char *fname,char *buf,long bufsize);

